<template>
  <div id="page">
  <div class="container">
    <h1 class="intro">Sounds & Letters</h1>
    <div class="blurb">
      <h2>{{ currentText }}</h2>
      <h3 class="wrapped-text">
        Introducing Sounds & Letters, an application that allows users to learn and read easily.
        With its intuitive interface and user friendliness,
        Sounds & Letters allows users to associate by leveraging visual and audio cues.
      </h3>
    </div>
    <div class="image">
      <slot name="right"></slot>
      <img :src="currentImage" class="image" alt="Image"/>
    </div>
  </div>

  <div class="button-container" style="margin-top: 250px;">
    <el-button type = "info" @click="pushLessonView">Lessons</el-button>
    <el-button type = "info" @click="pushGameView">Game</el-button>
    <el-button type = "info" @click="pushManageView">Create Lesson</el-button>
  </div>
  </div>
</template>

<style scoped>

#page{
  background-image:url(src/components/Backgrounds/background1.png);
}

.container {

  max-width: 1280px;
  margin: 0 auto;
  text-align: center;
}
.image {
  width: 150px;
  height: 150px;
  margin: 0 auto;
}

.button-container {
  display: flex;
  justify-content: center;
}

.el-button {
  font-size: 18px;
  width: 150px;
  height: 50px;
}
</style>


<script lang="ts">
import {defineComponent, ref, onMounted, onBeforeUnmount} from 'vue';
import router from "@/router/router.js";

export default defineComponent({
  setup() {
    const preface = 'Designed to help others ';
    // TODO Change Images
    const pairs = [
      {msg: 'learn', img: 'src/components/icons/brain.svg'},
      {msg: 'read', img: 'src/components/icons/book.svg'},
      {msg: 'associate', img: 'src/components/icons/columns.svg'}];
    const back = {msg:'background1', img:'src/components/Backgrounds/background1.png'};
    let pair = pairs[0];
    const currentImage = ref(pair.img);
    const currentText = ref(pair.msg);
    const currentIndex = ref(0);
    let interval: any = null;
    const background = ref(back.img);
    const startCarousel = () => {
      interval = setInterval(() => {
        currentIndex.value = (currentIndex.value + 1) % pairs.length;
        pair = pairs[currentIndex.value];
        currentImage.value = pair.img
        currentText.value = preface + pair.msg;
      }, 3000);
    };

    const stopCarousel = () => {
      clearInterval(interval);
    };

    const pushLessonView = () => {
      router.push('/lessons');
    };

    const pushGameView = () => {
      router.push('/game');
    };

    const pushManageView = () => {
      router.push('/manage');
    };

    onMounted(() => {
      startCarousel();
    });

    onBeforeUnmount(() => {
      stopCarousel();
    });

    return {
      currentImage,
      currentText,
      background,
      pushLessonView,
      pushGameView,
      pushManageView
    };
  },
});
</script>